CREATE OR REPLACE PROCEDURE ARQUIVO_MANAD(
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_ANO IN VARCHAR,
   P_CEI IN VARCHAR,
   P_NIT IN VARCHAR,
   P_SUFRAMA IN VARCHAR,
   P_IDESCRIT IN VARCHAR,
   P_FINALIDADE IN VARCHAR,
   P_DTCONTINI IN DATE,
   P_DTCONTFIN IN DATE,
   P_NMEMPRESAINF  IN VARCHAR,
   P_CNPJINF IN VARCHAR,
   P_CARGOINF  IN VARCHAR,
   P_CPFINF IN VARCHAR,
   P_TELINF IN VARCHAR,
   P_EMAILINF  IN VARCHAR,
   P_DTINFINI IN DATE,
   P_DTINFFIN IN DATE)
IS
   V_NRORDREGARQ INTEGER;
   V_AUXILIAR    VARCHAR2(2000);
   V_DATAFINAL DATE;
   V_DATAINICIAL DATE;
   V_CONTADOR NUMBER;
   V_VRDEBITO NUMBER;
   V_VRINICIAL NUMBER;
   V_VRCREDITO NUMBER;
   V_VRFINAL NUMBER;
   V_COMMIT NUMBER;
   V_DARCOMMIT NUMBER;
BEGIN
   V_COMMIT := 0;
   V_DARCOMMIT := 250;
   V_DATAINICIAL := P_DTCONTINI;
   V_DATAFINAL := P_DTCONTFIN;

   /********************************************************
    ATENO! A NATUREZA DE CONTA QUE VAI PARA O MANAD  1, 2, 3, 4 E 5!
    1. ATIVO
    2. PASSIVO
    3. PAT LIQUIDO
    4. DESPESA OU CUSTO
    5. RECEITAS
    LOGO  PRECISO RELACIONAR AS MESMAS CORRETAMENTE DENTRO DO SISTEMA, PORM, O
    SISTEMA AGLUTINA (POR CAUSA DA ECD) AS CONTAS DE RESULTADO NA NATUREZA 4.
    UMA SOLUO PARA ISSO  ORIENTAR AO CLIENTE PARA PARAMETRIZAR AS CONTAS DE RECEITA
    OU CUSTOS/DESPESAS COM A NATUREZA 5 (CONTAS DE COMPENSAO DENTRO DO SISTEMA) APENAS
    PARA VALIDAO DO ARQUIVO MANAD. PS ISSO, ELE PODE VOLTAR PARA A NATUREZA 4.
    ********************************************************/

   /********************************************************
      BLOCO 0 - ABERTURA DO ARQUIVO
    ********************************************************/

   /* Registro 0000 - Abertura do arquivo digital e identificao dos
      estabelecimentos (inclusive obras) do contribuinte. */

   SELECT '0000|' || /* Texto Fixo */
          E.NMRAZSOCEMPR     ||'|'|| /* Nome empresarial do contribuinte */
          E.NRINSJUREMPR     ||'|'|| /* CNPJ do contribuinte */
                               '|'|| /* CPF do contribuinte */
          P_CEI              ||'|'|| /* Nmero de inscrio no Cadastro Especfico do INSS */
          P_NIT              ||'|'|| /* Nmero de inscrio no cadastro
                                        correspondente (PIS/PASEP/CI/SUS)*/
          E.SGESTADO          ||'|'|| /* Estado da Empresa */
          NVL(E.NRINSCESTA,'')||'|'|| /* Nmero da Insc. Estadual da Empresa */
          LPAD(NVL(M.CDMUNICIBGE,'0'),7,'0') ||'|'|| /* Nmero do cdigo do Municpio */
          NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(NVL(E.CDINSCMUNI,''), ' ', ''),'.',''),',',''),'-',''),'/',''),'')|| '|' || /* Insc. Municipal da Empresa */
          P_SUFRAMA ||'|'|| /*Nmero de inscrio do contribuinte na SUFRAMA */
          P_IDESCRIT ||'|'|| /* Indicador de centralizao de escriturao:
                              0- Estabelecimento sem centralizao de escriturao;
                              1- Estabelecimento centralizador de escriturao;
                              2- Estabelecimento com escriturao centralizada. */
          TO_CHAR(V_DATAINICIAL, 'DDMMYYYY')||'|'|| /* Data inicial das informaes contidas no arquivo */
          TO_CHAR(V_DATAFINAL, 'DDMMYYYY')||'|'|| /* Data final das informaes contidas no arquivo */
          '003'||'|'|| /* Verso do leiaute */
          P_FINALIDADE||'|'||  /* Finalidade do arquivo:
                                  61 - Solicitao de Auditor-Fiscal da Secretaria da Receita Previdenciria
                                  62 - Entrega na Secretaria da Receita Previdenciria
                                  90 - Dados Internos UF */
                       '2' /* Indicador de tipo de entrada de dados:
                              0- Digitao de dados;
                              1- Importao de arquivo texto (arquivo construdo a partir da manipulao de dados
                                  extrados dos sistemas);
                              2- Validao de arquivo texto (arquivo gerado diretamente por sistema
                              informatizado, j no leiaute requerido) */


          AS DSLINHA
     INTO V_AUXILIAR
     FROM EMPRESA E, MUNICIPIO M
    WHERE E.CDPAIS = M.CDPAIS
      AND E.SGESTADO = M.SGESTADO
      AND E.CDMUNICIPIO = M.CDMUNICIPIO
      AND E.CDEMPRESA = P_CDEMPRESA;

   V_NRORDREGARQ := 0;
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;

   /* Registro 0001 - Abertura do bloco 0 */
   SELECT '0001|'|| /* Texto Fixo */
             '0'   /* Indicador de movimento
                        0- Bloco com dados informados;
                        1- Bloco sem dados informados */
     INTO V_AUXILIAR
     FROM DUAL;

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;

   /* Registro 0050 - Dados do Contabilista */
   BEGIN
      SELECT '0050|'|| /* Texto Fixo */
             C.NMCONTADOR  ||'|'||
                             '|'|| /* CNPJ DO ESCRITORIO DE CONTABILIDADE */
             C.NRINSJURCONT||'|'|| /* CPF DO CONTADOR */
             C.NRCRCCONT2  ||'|'|| /* NUMERO DE REGISTRO NO CRC */
             TO_CHAR(P_DTCONTINI, 'DDMMYYYY')||'|'|| /* DATA DE INICIO DE PRESTACAO DE SERVICO CONTABIL */
             TO_CHAR(P_DTCONTFIN, 'DDMMYYYY')||'|'|| /* DATA FINAL DE PRESTACAO DE SERVICO CONTABIL */
             C.DSLOGRADOURO  ||'|'|| /* Endereo */
             '000000'        ||'|'|| /* Nmero */
             C.DSCOMPLLOGRA  ||'|'|| /* Complemento */
             C.DSBAIRRO      ||'|'|| /* BAIRRO */
             C.NRCEP         ||'|'|| /* CEP */
             C.SGESTADO      ||'|'|| /* ESTADO */
                               '|'|| /* CAIXA POSTAL */
                               '|'|| /* CEP DA CAIXA POSTAL */
             REPLACE(REPLACE(C.NRTELCONTATO, '-', ' '), ' ', '')  ||'|'|| /* TELEFONE */
             C.NRFAXCONTATO||'|'|| /* FAX */
             C.DSENDINTERN  /* EMAIL */
        INTO V_AUXILIAR
        FROM EMPRESA E, CONTADOR C
       WHERE E.CDEMPRESA = P_CDEMPRESA
         AND E.CDCONTADOR2 = C.CDCONTADOR2;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_AUXILIAR := NULL;
   END;

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;

   /* Registro 0100 - Dados do tcnico/empresa responsvel pela gerao do arquivo digital */
   SELECT '0100|'|| /* Texto Fixo */
          P_NMEMPRESAINF ||'|'||
          P_CARGOINF ||'|'||
          TO_CHAR(P_DTINFINI, 'DDMMYYYY')||'|'|| /* Data de incio da prestao do servio de
                                                    informtica (fornecimento do sistema de gerao dos arquivos
                                                    digitais)*/
          TO_CHAR(P_DTINFFIN, 'DDMMYYYY')||'|'|| /* Data de trmino da prestao do servio de informtica */
          P_CNPJINF||'|'|| /* Nmero de inscrio da empresa responsvel pela gerao do arquivo no CNPJ */
          P_CPFINF||'|'|| /* Nmero de inscrio do tcnico responsvel pela gerao do arquivo no CPF */
          REPLACE(P_TELINF, ' ', '')||'|'|| /* Nmero do telefone */
                      '|'|| /* Fax */
          P_EMAILINF /* Email */
     INTO V_AUXILIAR
     FROM DUAL;

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;

   /* Encerramento Bloco 0 */
   SELECT '0990|'||
          TO_CHAR(COUNT(*) + 1) AS DSLINHA
     INTO V_AUXILIAR
     FROM ARQMAGNETICO
    WHERE NRSEQARQMAG = P_NRSEQARQMAG
      AND SUBSTR(DSREGARQMAG, 1, 1) = '0';
      V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;


   /********************************************************
      BLOCO I - LANAMENTOS E SALDOS CONTBEIS
    ********************************************************/
   /* Registro I001 - Abertura bloco I */
   SELECT 'I001|'|| /* Texto Fixo */
          '0'       /* Indicador de movimento:
                        0- Bloco com dados informados;
                        1- Bloco sem dados informados. */
     INTO V_AUXILIAR
     FROM DUAL;

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;

   /* Registro I005 - Identificao da escriturao contbil */
   SELECT 'I005|'|| /* Texto Fixo */
            'G|'    /* G=Diario Geral A-Razao Auxiliar */
     INTO V_AUXILIAR
     FROM DUAL;   
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;

   /* Registro I050 - Plano de contas */
   FOR C_CONTAS_I050 IN
      (SELECT C.CDCONTCTBL,
              'I050'||'|'||
              TO_CHAR(V_DATAINICIAL, 'DDMMYYYY')||'|'||
              DECODE(NVL(CONTSINT.IDNATUCONT, CONTANAL.IDNATUCONT), '4',
              DECODE(SUBSTR(C.CDCONTCTBL, 1, 1), '3', '5', '4'), /* Comear com 3  receita, senao custo ou despesa */
              NVL(CONTSINT.IDNATUCONT, CONTANAL.IDNATUCONT))||'|'||
              C.IDTIPOCONT||'|'||
              C.CDNVCONTCTBL||'|'||
              C.CDCONTCTBL||'|'||
              C.CDCONTANTE||'|'||
              C.NMCONTCTBL AS DSLINHA
         FROM CONTCTBL C LEFT JOIN (SELECT C.CDCONTCTBL, TO_CHAR(TO_NUMBER(IDNATUCONT)) IDNATUCONT,
                                           MIN(DTCRIACAO) DTCRI
                                      FROM CONTCTBL C LEFT JOIN (SELECT CDCONTCTBL, MIN(DTLANCCONT) DTCRIACAO
                                                                   FROM LANCCONT
                                                                  WHERE CDEMPRESA = P_CDEMPRESA
                                                                  GROUP BY CDCONTCTBL) DATAS
                                                             ON DATAS.CDCONTCTBL LIKE C.CDCONTCTBL||'%'
                                     WHERE  C.IDTIPOCONT = 'S'
                                     GROUP BY C.CDCONTCTBL, TO_CHAR(TO_NUMBER(IDNATUCONT))
                                     ORDER BY C.CDCONTCTBL) CONTSINT
                                ON CONTSINT.CDCONTCTBL = C.CDCONTCTBL
                         LEFT JOIN (SELECT C.CDCONTCTBL, TO_CHAR(TO_NUMBER(IDNATUCONT)) IDNATUCONT,
                                           MIN(DTLANCCONT) DTCRI
                                      FROM CONTCTBL C LEFT JOIN LANCCONT L
                                                             ON C.CDCONTCTBL = L.CDCONTCTBL
                                                            AND L.CDEMPRESA = P_CDEMPRESA
                                     GROUP BY C.CDCONTCTBL, TO_CHAR(TO_NUMBER(IDNATUCONT))) CONTANAL
                                ON CONTANAL.CDCONTCTBL = C.CDCONTCTBL
        ORDER BY 1) LOOP
      V_NRORDREGARQ := V_NRORDREGARQ + 1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_CONTAS_I050.DSLINHA, P_NRSEQARQMAG);
      V_COMMIT := V_COMMIT + 1;
      IF V_COMMIT = V_DARCOMMIT THEN
         V_COMMIT := 0;
         COMMIT;
      END IF;
   END LOOP;

   /* Registro I100 - Centro de custos*/
   FOR C_CCUSTO_I100 IN
      (SELECT 'I100|'        || /* TEXTO FIXO */
               TO_CHAR(MIN(DTLANCCONT), 'DDMMYYYY')||'|'|| /* DATA CRIACAO CENTRO DE CUSTO */
               CDCENTCUST||'|'|| /* CODIGO DO CENTRO DE CUSTO */
               NMCENTCUST   /* NOME DO CENTRO DE CUSTO */
               AS DSLINHA, CDCENTCUST
         FROM CENTCUST, LANCCONT L
        WHERE L.CDEMPRESA = P_CDEMPRESA
        GROUP BY CDCENTCUST, NMCENTCUST
        ORDER BY CDCENTCUST) LOOP
      V_NRORDREGARQ := V_NRORDREGARQ + 1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_CCUSTO_I100.DSLINHA, P_NRSEQARQMAG);
      V_COMMIT := V_COMMIT + 1;
      IF V_COMMIT = V_DARCOMMIT THEN
         V_COMMIT := 0;
         COMMIT;
      END IF;
   END LOOP;

   /* Registro I150 - Saldos Peridicos */
   FOR C_DATA IN (
      SELECT DISTINCT SUBSTR(DTDATA,4,8) DTDATA
        FROM DATA
       WHERE DTMES BETWEEN V_DATAINICIAL AND V_DATAFINAL
    ORDER BY 1) LOOP
      FOR C_CONTA IN (SELECT CDCONTCTBL
                        FROM CONTCTBL
                       WHERE IDCONTCCUS <> 'R'
                         AND IDTIPOCONT = 'A'
                      ORDER BY CDCONTCTBL) LOOP

         BEGIN
            SELECT S.VRSALDEMPR AS VRSALDINI
              INTO V_VRINICIAL
              FROM SALDEMPR S
             WHERE S.CDEMPRESA = P_CDEMPRESA
               AND S.DTSALDEMPR = TO_DATE('01/'||C_DATA.DTDATA) -1
               AND S.CDCONTCTBL = C_CONTA.CDCONTCTBL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRINICIAL := 0;
         END;

         BEGIN
            SELECT SUM(ROUND(VRLANCAMENT,2)) AS DEBITO
              INTO V_VRDEBITO
              FROM LANCCONT
             WHERE CDEMPRESA = P_CDEMPRESA
               AND CDCONTCTBL = C_CONTA.CDCONTCTBL
               AND DTLANCCONT BETWEEN '01/'||C_DATA.DTDATA and LAST_DAY('01/'||C_DATA.DTDATA)
               AND VRLANCAMENT < 0;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRDEBITO := 0;
         END;

         BEGIN
            SELECT SUM(ROUND(VRLANCAMENT,2)) AS CREDITO
              INTO V_VRCREDITO
              FROM LANCCONT
             WHERE CDEMPRESA = P_CDEMPRESA
               AND CDCONTCTBL = C_CONTA.CDCONTCTBL
               AND DTLANCCONT BETWEEN '01/'||C_DATA.DTDATA and LAST_DAY('01/'||C_DATA.DTDATA)
               AND VRLANCAMENT > 0;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRCREDITO := 0;
         END;

         BEGIN
            SELECT S.VRSALDEMPR AS VRSALDFIN
              INTO V_VRFINAL
              FROM SALDEMPR S
             WHERE S.CDEMPRESA  = P_CDEMPRESA
               AND S.CDCONTCTBL = C_CONTA.CDCONTCTBL
               AND S.DTSALDEMPR = LAST_DAY('01/'||C_DATA.DTDATA);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRFINAL := 0;
         END;

         SELECT 'I150|'||
                C_CONTA.CDCONTCTBL||'|'||
                REPLACE(C_DATA.DTDATA, '/', '')||'|'||
                REPLACE(LTRIM(TO_CHAR(ABS(NVL(V_VRINICIAL,0)),'9999999999990.00')||'|'||DECODE(V_VRINICIAL, ABS(V_VRINICIAL), 'C', 'D')),'.',',') ||'|'||
                REPLACE(LTRIM(TO_CHAR(ABS(NVL(V_VRDEBITO,0)),'9999999999990.00')),'.',',') ||'|'||
                REPLACE(LTRIM(TO_CHAR(NVL(V_VRCREDITO,   0), '9999999999990.00')),'.',',') ||'|'||
                REPLACE(LTRIM(TO_CHAR(ABS(NVL(V_VRFINAL, 0)),'9999999999990.00')||'|'||DECODE(V_VRFINAL, ABS(V_VRFINAL), 'C', 'D')),'.',',')
           INTO V_AUXILIAR
           FROM DUAL;
            V_NRORDREGARQ := V_NRORDREGARQ + 1;
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
         V_COMMIT := V_COMMIT + 1;
         IF V_COMMIT = V_DARCOMMIT THEN
            V_COMMIT := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;

   /* Registro I200 - Lanamentos Contbeis */
   FOR C_QTPART IN
      (SELECT CDEMPRESA, DTLANCCONT, NRLANCCONT, SUM(DEB) QTDEB, SUM(CRED) QTCRED
         FROM (SELECT CDEMPRESA, DTLANCCONT, NRLANCCONT, COUNT(*) DEB, 0 CRED
                 FROM LANCCONT L
                WHERE L.DTLANCCONT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                  AND L.CDEMPRESA = P_CDEMPRESA
                  AND L.VRLANCAMENT < 0
                GROUP BY CDEMPRESA, DTLANCCONT, NRLANCCONT
                UNION ALL
               SELECT CDEMPRESA, DTLANCCONT, NRLANCCONT, 0 DEB, COUNT(*) CRED
                 FROM LANCCONT L
                WHERE L.DTLANCCONT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                  AND L.CDEMPRESA = P_CDEMPRESA
                  AND L.VRLANCAMENT > 0
                GROUP BY CDEMPRESA, DTLANCCONT, NRLANCCONT)
        GROUP BY CDEMPRESA, DTLANCCONT, NRLANCCONT
        ORDER BY 1, 2, 3) LOOP
      IF C_QTPART.QTDEB > 1 AND C_QTPART.QTCRED > 1 THEN
         FOR C_LANC_I200 IN
            (SELECT 'I200' ||'|'||
                    TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                    L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                       '|'|| /* Centro de Custo */
                                                       '|'|| /* Conta contra partida */
                    REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                    DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                    L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                    L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                    DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                    L.DSHISTLANC AS DSLINHA, L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC
               FROM LANCCONT L
              WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
                AND L.CDEMPRESA = P_CDEMPRESA
              ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC)LOOP
             V_NRORDREGARQ := V_NRORDREGARQ + 1;
             INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_LANC_I200.DSLINHA, P_NRSEQARQMAG);
             V_COMMIT := V_COMMIT + 1;
            IF V_COMMIT = V_DARCOMMIT THEN
               V_COMMIT := 0;
               COMMIT;
            END IF;
         END LOOP;
      ELSIF C_QTPART.QTDEB = 1 AND C_QTPART.QTCRED > 1 THEN
         FOR C_DEBITOS IN
            (SELECT 'I200' ||'|'||
                    TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                    L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                       '|'|| /* Centro de Custo */
                                                       '|'|| /* Conta contra partida */
                    REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                    DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                    L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                    L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                    DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                    L.DSHISTLANC AS DSLINHA, L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC, L.CDCONTCTBL
               FROM LANCCONT L
              WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
                AND L.CDEMPRESA = P_CDEMPRESA
                AND L.VRLANCAMENT < 0
              ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC) LOOP
             /* PARTIDA DE DEBITO */ 
             V_NRORDREGARQ := V_NRORDREGARQ + 1;
             INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_DEBITOS.DSLINHA, P_NRSEQARQMAG);
             V_COMMIT := V_COMMIT + 1;
            IF V_COMMIT = V_DARCOMMIT THEN
               V_COMMIT := 0;
               COMMIT;
            END IF;
            /* PARTIDAS DE CRDITO */
            FOR C_CREDITOS IN
               (SELECT 'I200' ||'|'||
                       TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                       L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                          '|'|| /* Centro de Custo */
                       C_DEBITOS.CDCONTCTBL             ||'|'|| /* Conta contra partida */
                       REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                       DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                       L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                       L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                       DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                       L.DSHISTLANC AS DSLINHA, L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC, L.CDCONTCTBL
                  FROM LANCCONT L
                 WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
                   AND L.CDEMPRESA = P_CDEMPRESA
                   AND L.NRSEQLANC <> C_DEBITOS.NRSEQLANC
                 ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC) LOOP
                V_NRORDREGARQ := V_NRORDREGARQ + 1;
                INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                  (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_CREDITOS.DSLINHA, P_NRSEQARQMAG);
                V_COMMIT := V_COMMIT + 1;
               IF V_COMMIT = V_DARCOMMIT THEN
                  V_COMMIT := 0;
                  COMMIT;
               END IF;
            END LOOP;
         END LOOP;
      ELSIF C_QTPART.QTDEB > 1 AND C_QTPART.QTCRED = 1 THEN
         FOR C_CREDITOS IN
            (SELECT 'I200' ||'|'||
                    TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                    L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                       '|'|| /* Centro de Custo */
                                                       '|'|| /* Conta contra partida */
                    REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                    DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                    L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                    L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                    DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                    L.DSHISTLANC AS DSLINHA, L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC, L.CDCONTCTBL
               FROM LANCCONT L
              WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
                AND L.CDEMPRESA = P_CDEMPRESA
                AND L.VRLANCAMENT > 0
              ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC) LOOP
             /* PARTIDA DE DEBITO */ 
             V_NRORDREGARQ := V_NRORDREGARQ + 1;
             INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_CREDITOS.DSLINHA, P_NRSEQARQMAG);
             V_COMMIT := V_COMMIT + 1;
            IF V_COMMIT = V_DARCOMMIT THEN
               V_COMMIT := 0;
               COMMIT;
            END IF;
            /* PARTIDAS DE CRDITO */
            FOR C_DEBITOS IN
               (SELECT 'I200' ||'|'||
                       TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                       L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                          '|'|| /* Centro de Custo */
                       C_CREDITOS.CDCONTCTBL             ||'|'|| /* Conta contra partida */
                       REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                       DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                       L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                       L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                       DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                       L.DSHISTLANC AS DSLINHA, L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC, L.CDCONTCTBL
                  FROM LANCCONT L
                 WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
                   AND L.CDEMPRESA = P_CDEMPRESA
                   AND L.NRSEQLANC <> C_CREDITOS.NRSEQLANC
                 ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC) LOOP
                V_NRORDREGARQ := V_NRORDREGARQ + 1;
                INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                  (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_DEBITOS.DSLINHA, P_NRSEQARQMAG);
                V_COMMIT := V_COMMIT + 1;
               IF V_COMMIT = V_DARCOMMIT THEN
                  V_COMMIT := 0;
                  COMMIT;
               END IF;
            END LOOP;
         END LOOP;
      ELSE  /* 1 CREDITO E 1 DEBITO */
         BEGIN
            SELECT 'I200' ||'|'||
                   TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                   L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                      '|'|| /* Centro de Custo */
                   CONTPARTIDA.CDCONTCTBL           ||'|'|| /* Conta contra partida */
                   REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                   DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                   L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                   L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                   DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                   L.DSHISTLANC
              INTO V_AUXILIAR
              FROM LANCCONT L, (SELECT CDCONTCTBL
                                  FROM LANCCONT LC
                                 WHERE LC.CDEMPRESA = P_CDEMPRESA
                                   AND LC.NRLANCCONT = C_QTPART.NRLANCCONT
                                   AND LC.VRLANCAMENT > 0) CONTPARTIDA
             WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
               AND L.CDEMPRESA = P_CDEMPRESA
               AND L.VRLANCAMENT < 0
             ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_AUXILIAR := NULL;
         END;

         /* PARTIDA DE DEBITO */
         V_NRORDREGARQ := V_NRORDREGARQ + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
         V_COMMIT := V_COMMIT + 1;
         IF V_COMMIT = V_DARCOMMIT THEN
            V_COMMIT := 0;
            COMMIT;
         END IF;

         /* PARTIDA DE CREDITO */
         BEGIN
            SELECT 'I200' ||'|'||
                   TO_CHAR(L.DTLANCCONT, 'DDMMYYYY')||'|'|| /* Data do Lancamento */
                   L.CDCONTCTBL                     ||'|'|| /* Conta Contbil */
                                                      '|'|| /* Centro de Custo */
                   CONTPARTIDA.CDCONTCTBL           ||'|'|| /* Conta contra partida */
                   REPLACE(LTRIM(TO_CHAR(NVL(ABS(ROUND(VRLANCAMENT,2)),0), '9999999999990.00')),'.',',') ||'|'||  /* Valor Partida */
                   DECODE(VRLANCAMENT, ABS(VRLANCAMENT), 'C', 'D')||'|'|| /* Debito ou Crdito */
                   L.CDDOCUCONT ||'|'|| /* Nmero ou cdigo de arquivamento */
                   L.NRLANCCONT ||'|'|| /* Nmero do lanamento Contbil */
                   DECODE(L.IDLANCINTE, 'E', 'E', 'N') ||'|'|| /* E-ENCERRAMENTO N-NORMAL */
                   L.DSHISTLANC
              INTO V_AUXILIAR
              FROM LANCCONT L, (SELECT CDCONTCTBL
                                  FROM LANCCONT LC
                                 WHERE LC.CDEMPRESA = P_CDEMPRESA
                                   AND LC.NRLANCCONT = C_QTPART.NRLANCCONT
                                   AND LC.VRLANCAMENT < 0) CONTPARTIDA
             WHERE L.NRLANCCONT = C_QTPART.NRLANCCONT
               AND L.CDEMPRESA = P_CDEMPRESA
               AND L.VRLANCAMENT > 0
             ORDER BY L.DTLANCCONT, L.NRLANCCONT, L.NRSEQLANC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_AUXILIAR := NULL;
         END;

         /* PARTIDA DE CREDITO */
         V_NRORDREGARQ := V_NRORDREGARQ + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'),V_AUXILIAR, P_NRSEQARQMAG);
         V_COMMIT := V_COMMIT + 1;
         IF V_COMMIT = V_DARCOMMIT THEN
            V_COMMIT := 0;
            COMMIT;
         END IF;
      END IF;
   END LOOP;

   /* Saldos das contes antes do encerramento */
   FOR C_ENC_I250 IN
      (SELECT 'I250' ||'|'||
              TO_CHAR(V_DATAFINAL, 'DDMMYYYY')||'|'||
              C.CDCONTCTBL                    ||'|'||
              REPLACE(LTRIM(TO_CHAR(ABS(NVL(NVL(ST.VRSALDOTRANSF, S.VRSALDEMPR), 0)),'9999999999990.00')), '.', ',')|| '|' ||
              DECODE(NVL(NVL(ST.VRSALDOTRANSF, S.VRSALDEMPR), 0), ABS(NVL(NVL(ST.VRSALDOTRANSF, S.VRSALDEMPR), 0)), 'C', 'D') AS DSLINHA
         FROM SALDOTRANSF ST, SALDEMPR S, CONTCTBL C
        WHERE S.CDEMPRESA = P_CDEMPRESA
          AND S.DTSALDEMPR = LAST_DAY(V_DATAFINAL)
          AND S.CDCONTCTBL = C.CDCONTCTBL
          AND C.IDTIPOCONT = 'A'
          AND C.IDNATUCONT = '04'
          AND C.IDCONTCCUS <> 'R'
          AND S.DTSALDEMPR = ST.DTSALDOTRANSF(+)
          AND S.CDEMPRESA = ST.CDEMPRESA(+)
          AND S.CDCONTCTBL = ST.CDCONTCTBL(+)
        ORDER BY S.CDCONTCTBL ASC, S.DTSALDEMPR, ST.CDCONTCTBL ASC, ST.DTSALDOTRANSF)LOOP

      V_NRORDREGARQ := V_NRORDREGARQ + 1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_ENC_I250.DSLINHA, P_NRSEQARQMAG);
   END LOOP;

   /* Encerramento Bloco 0 */
   SELECT 'I990|'||
          TO_CHAR(COUNT(*) + 1) AS DSLINHA
     INTO V_AUXILIAR
     FROM ARQMAGNETICO
    WHERE NRSEQARQMAG = P_NRSEQARQMAG
      AND SUBSTR(DSREGARQMAG, 1, 1) = 'I';
      V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   V_COMMIT := V_COMMIT + 1;
   IF V_COMMIT = V_DARCOMMIT THEN
      V_COMMIT := 0;
      COMMIT;
   END IF;


   /***********************************************
       Bloco 9 - Encerramento
    ***********************************************/
   V_AUXILIAR := '9001|0';
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);

   V_CONTADOR := 1;
   FOR C_9900 IN (
   SELECT '9900|'||
          SUBSTR(DSREGARQMAG,1,4)||'|'||
          TO_CHAR(COUNT(*)) AS DSLINHA
   FROM ARQMAGNETICO
   WHERE NRSEQARQMAG = P_NRSEQARQMAG
     AND SUBSTR(DSREGARQMAG,1,1) <> '9'
   GROUP BY SUBSTR(DSREGARQMAG,1,4)
   ORDER BY SUBSTR(DSREGARQMAG,1,4)) LOOP
      V_NRORDREGARQ := V_NRORDREGARQ + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_9900.DSLINHA, P_NRSEQARQMAG);

      V_CONTADOR := V_CONTADOR + 1;
   END LOOP;

   V_AUXILIAR := '9900|9001|1';
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);

   V_AUXILIAR := '9900|9900|'|| TO_CHAR(V_CONTADOR + 3);
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);

   V_AUXILIAR := '9900|9990|1';
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);

   V_AUXILIAR := '9900|9999|1';
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);

   SELECT '9990|'||
          TO_CHAR(COUNT(*) + 1) AS DSLINHA
   INTO V_AUXILIAR
   FROM ARQMAGNETICO
   WHERE NRSEQARQMAG = P_NRSEQARQMAG
     AND SUBSTR(DSREGARQMAG,2,1) = '9';

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);

   SELECT '9999|'||
          TO_CHAR(COUNT(*) + 1) AS DSLINHA,
          (COUNT(*) + 1) AS NRCONTADOR
   INTO V_AUXILIAR, V_CONTADOR
   FROM ARQMAGNETICO
   WHERE NRSEQARQMAG = P_NRSEQARQMAG;

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_AUXILIAR, P_NRSEQARQMAG);
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_MANAD','5.85.xxx'); END;
/
